--- exiv2-0.25-old/src/canonmn.cpp	2015-05-22 04:18:31.000000000 +0100
+++ exiv2-0.25-new/src/canonmn.cpp	2015-09-29 22:18:50.562207860 +0100
@@ -66,6 +66,9 @@
     std::ostream& printCsLensByFocalLength(std::ostream& os,
                                            const Value& value,
                                            const ExifData* metadata);
+    std::ostream& printCsLensByFocalLengthTC(std::ostream& os,
+                                           const Value& value,
+                                           const ExifData* metadata);
 
     //! ModelId, tag 0x0010
     extern const TagDetails canonModelId[] = {
@@ -798,6 +801,7 @@
         { 173, "Canon EF 180mm Macro f/3.5L"                                }, // 0
         { 173, "Sigma 180mm EX HSM Macro f/3.5"                             }, // 1
         { 173, "Sigma APO Macro 150mm f/3.5 EX DG IF HSM"                   }, // 2
+        { 173, "Sigma 150-500mm f/5-6.3 APO DG OS HSM + 2x"                 }, // 3
         { 174, "Canon EF 135mm f/2L"                                        }, // 0
         { 174, "Sigma 70-200mm f/2.8 EX DG APO OS HSM"                      }, // 1
         { 174, "Sigma 50-500mm f/4.5-6.3 APO DG OS HSM"                     }, // 2
@@ -949,7 +953,7 @@
         { 161, printCsLensByFocalLength },
         { 169, printCsLensByFocalLength },
         { 172, printCsLensByFocalLength }, // not tested
-        { 173, printCsLensByFocalLength }, // works partly
+        { 173, printCsLensByFocalLengthTC }, // works partly
         { 174, printCsLensByFocalLength }, // not tested
         { 180, printCsLensByFocalLength },
         { 183, printCsLensByFocalLength }, // not tested
@@ -1632,6 +1636,26 @@
         const TagDetails* td = find(canonCsLensType, ltfl);
         if (!td) return os << value;
         return os << td->label_;
+    }
+
+    std::ostream& printCsLensByFocalLengthTC(std::ostream& os,
+                                             const Value& value,
+                                             const ExifData* metadata)
+    {
+        if (   !metadata || value.typeId() != unsignedShort
+            || value.count() == 0) return os << value;
+
+        LensTypeAndFocalLengthAndMaxAperture ltfl;
+        ltfl.lensType_ = value.toLong();
+
+        extractLensFocalLength(ltfl, metadata);
+        if (ltfl.focalLength_.empty()) return os << value;
+
+        if (ltfl.lensType_ == 173 && ltfl.focalLength_.compare("300-1000mm") == 0)
+            return os << "Sigma 150-500mm f/5-6.3 APO DG OS HSM + 2x";
+        const TagDetails* td = find(canonCsLensType, ltfl);
+        if (!td) return os << value;
+        return os << td->label_;
     }
 
     std::ostream& CanonMakerNote::printCsLensType(std::ostream& os,
